<template>
  <div class="container">
    <section class="hero">
      <div class="hero-body">
        <div class="container">
          <h1 class="title">
            YALS Link Shortener
          </h1>
          <h2 class="subtitle">
            YALS (Yet another link shortener) provides short(er) links to long URLs for things like Google Slides and other places.  
            <br/><br/>
            All links are in the form <code>labwork.dev/go/abc123</code>
          </h2>
        </div>
      </div>
    </section>

    <section class="columns container mainsection">
      <div class="column is-two-thirds">
        <h2 class="is-size-3">Your Links</h2>

        <div v-if="urlList.length > 0">
          <shortcard 
            v-for="(item, index) in urlList"
            v-bind:key="index"
            :shortcode="item.shortcode" 
            :linktitle="item.linktitle"
            :createdAt="item.createdAt"
            :clickCount="item.clickCount"
          />
        </div>
        <div v-else class="has-text-centered">
          <span v-if="isLoading">
            <br/><br/><br/>
            <button class="button is-loading is-white is-large">Loading</button>
          </span>
          <span v-else class="button is-light emptystate">
            <h3 class="is-size-5">
              No short URLs yet.
            </h3>
          </span>
        </div>
      </div>
      <div class="column">
        <h2 class="is-size-3">
          <span class="icon is-small small-header-icon">
            <i class="fas fa-plus"></i>
          </span>
          Add Link
        </h2>

        <div class="card">
          <div class="card-content">
            <h3 class="is-size-5">Your link</h3>
            <div class="field">
              <label class="label">Long URL</label>
              <div class="control">
                <input 
                  class="input" type="text" 
                  placeholder="https://docs.google.com/presentation/d/1hnYT7ulTPpb7C3V_fKdOU9gajAA1oufzp9EiDYQC-mU/edit#slide=id.g765d16dade_0_103"
                  v-model="longURL"
                />
              </div>
            </div>

            <h3 class="is-size-5">Becomes</h3>
            <span  class="linkdisplay">
              <code>labwork.dev/go/<span :class="((this.showBackHalf) ? 'is-hidden' : '')">xyz123</span></code>
            </span>
            <div class="field" :class="((this.showBackHalf) ? '' : 'is-hidden')">
              <label class="label">Back half</label>
              <div class="control">
                <input class="input" type="text" placeholder="abc123" v-model="requestedShort">
              </div>
            </div>
            <br/>
            <transition>
              <div class="notification is-success is-light" v-if="showSuccess">
                Created!
              </div>
              <div class="notification is-danger is-light" v-if="showExisitsError">
                <button class="delete" @click="showExisitsError = false"></button>
                Short code already exisits, please try again.
              </div>
              <div class="notification is-danger is-light" v-if="showGeneralError">
                <button class="delete" @click="showGeneralError = false"></button>
                Something went wrong, please try again.
              </div>
            </transition>
            <div class="field">
              <p class="control is-pulled-right">
                <button 
                  class="button is-primary" 
                  id="addLink" 
                  @click="addShort()"
                  :disabled="!allowAdd">
                  <span class="icon is-small">
                    <i class="fas fa-plus"></i>
                  </span>
                  <span>Add</span>
                </button>
              </p>
            </div>
            <br/>
            <br/>
          </div>
        </div>
      </div>
    </section>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapState } from 'vuex';
import * as firebase from 'firebase/app';
import 'firebase/functions';
import 'firebase/firestore';

const db = firebase.firestore();
const functions = firebase.functions();

import shortcard from '@/components/shortener-card.vue';

//https://www.youtube.com/watch?v=dQw4w9WgXcQ
export default Vue.extend({
  data() {
    return {
      longURL: '',
      requestedShort: '',
      isLoading: true,
      showExisitsError: false,
      showGeneralError: false,
      showSuccess: false,
      urlList: [],
    }
  },
  components: {
    shortcard,
  },
  created()  {
    this.$bind('urlList', db.collection('urls').where('userId', '==', this.user.data.uid).orderBy('createdAt', 'desc')).then(vals => {

    }).finally(() => {
      setTimeout(() => {
        this.isLoading = false
      }, 1000);
    })
  },
  methods: {
    addShort() {
      const btnAdd = <HTMLElement>document.getElementById('addLink');
      btnAdd.classList.add('is-loading');

      const addShortner = functions.httpsCallable('addShortner');
      addShortner({ longurl: this.longURL, requestedShort: this.requestedShort })
      .then(val => {
        this.showSuccess = true;
        setTimeout(() => {
          this.showSuccess = false;
        }, 1500);
      })
      .catch(e => {
        console.error(e);
        if (e.message.indexOf('already exisits') > -1) { this.showExisitsError = true } else {
          this.showGeneralError = true;
        }
      })
      .finally(() => { btnAdd.classList.remove('is-loading'); })
    },
    shortOk() {
      return true;
    },
    isUrl() {
      var regexp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/
      return regexp.test(this.longURL);
    }
  },
  computed: {
    showBackHalf() {
      return true;
    },
    allowAdd() {
      return (!(this.longURL === '') && this.isUrl())
    },
    ...mapState(['user'])
  },
})
</script>

<style scoped>
.mainsection {
  margin-bottom: 3em;
}

.emptystate {
  margin-top: 2.5em;
  padding: 2.5em;
}
</style>
